local GameTimeFrame, MiniMapWorldMapButton, Minimap, MinimapBorder, MinimapBorderTop, MinimapCluster, MinimapNorthTag, MinimapToggleButton, MinimapZoneText, MinimapZoneTextButton, MinimapZoomIn, MinimapZoomOut, UIParent, idTweaks, idTweaksActionBar1, idTweaksExperienceBar, idTweaksModule, idTweaksOptions, TL, TC, TR, ML, MC, MR, BL, BC, BR, Option, ToggleOption, MiniMap, minimap_module, GetMinimapShape
do
  local _obj_0 = _G
  GameTimeFrame, MiniMapWorldMapButton, Minimap, MinimapBorder, MinimapBorderTop, MinimapCluster, MinimapNorthTag, MinimapToggleButton, MinimapZoneText, MinimapZoneTextButton, MinimapZoomIn, MinimapZoomOut, UIParent, idTweaks, idTweaksActionBar1, idTweaksExperienceBar, idTweaksModule, idTweaksOptions = _obj_0.GameTimeFrame, _obj_0.MiniMapWorldMapButton, _obj_0.Minimap, _obj_0.MinimapBorder, _obj_0.MinimapBorderTop, _obj_0.MinimapCluster, _obj_0.MinimapNorthTag, _obj_0.MinimapToggleButton, _obj_0.MinimapZoneText, _obj_0.MinimapZoneTextButton, _obj_0.MinimapZoomIn, _obj_0.MinimapZoomOut, _obj_0.UIParent, _obj_0.idTweaks, _obj_0.idTweaksActionBar1, _obj_0.idTweaksExperienceBar, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaks.anchor
  TL, TC, TR, ML, MC, MR, BL, BC, BR = _obj_0.TL, _obj_0.TC, _obj_0.TR, _obj_0.ML, _obj_0.MC, _obj_0.MR, _obj_0.BL, _obj_0.BC, _obj_0.BR
end
do
  local _obj_0 = idTweaksOptions
  Option, ToggleOption = _obj_0.Option, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(Option(self, "shape", "Shape", "Shape settings", { }, {
        square = ToggleOption(self, "square", "Square", "Makes the minimap square", {
          check = function()
            return self:shape_square_check()
          end
        })
      }))
      self.options:add_option(Option(self, "mouse", "Mouse", "Change how the mouse interacts with the MiniMap.", { }, {
        mouse_wheel_zooming = ToggleOption(self, "mouse_wheel_zooming", "Mouse Wheel Zooming", "Enables Zooming the minimap with the Mouse Wheel.", {
          check = function()
            return self:mouse_mousewheel_zooming_check()
          end
        })
      }))
      self.options:add_option(Option(self, "hide", "Hide", "Toggle visibility of parts of the MiniMap with these options.", { }, {
        area_text = ToggleOption(self, "area_text", "Area Text", "Area Text", {
          check = function()
            return self:hide_check()
          end
        }),
        calendar_button = ToggleOption(self, "calendar_button", "Calendar Button", "Calendar Button", {
          check = function()
            return self:hide_check()
          end
        }),
        north_tag = ToggleOption(self, "north_tag", "North Tag", "North Tag", {
          check = function()
            return self:hide_check()
          end
        }),
        time_display = ToggleOption(self, "time_display", "Time Display", "Time Display", {
          check = function()
            return self:hide_check()
          end
        }),
        worldmap_button = ToggleOption(self, "worldmap_button", "World Map Button", "World Map Button", {
          check = function()
            return self:hide_check()
          end
        }),
        zoom_buttons = ToggleOption(self, "zoom_buttons", "Zoom Buttons", "Zoom Buttons", {
          check = function()
            return self:hide_check()
          end
        })
      }))
      if idTweaks:is_bc() then
        return (self.options:get_option("hide")):add_option(ToggleOption(self, "close_button", "Close Button", "Close Button", {
          check = function()
            return self:hide_check()
          end
        }))
      end
    end,
    enable = function(self)
      return self:check()
    end,
    disable = function(self)
      self:hide_disable()
      self:shape_square_disable()
      self:shape_position_disable()
      return self:mouse_disable()
    end,
    check = function(self)
      self:hide_check()
      self:shape_square_check()
      self:shape_position_check()
      return self:mouse_check()
    end,
    positioning = function(self)
      self:shape_square_check()
      return self:shape_position_check()
    end,
    hide_frames = {
      area_text = {
        enable = function(self)
          MinimapBorderTop:Hide()
          MinimapZoneText:Hide()
          return MinimapZoneTextButton:Hide()
        end,
        disable = function(self)
          MinimapBorderTop:Show()
          MinimapZoneText:Show()
          return MinimapZoneTextButton:Show()
        end
      },
      calendar_button = {
        enable = function(self)
          return GameTimeFrame:Hide()
        end,
        disable = function(self)
          return GameTimeFrame:Show()
        end
      },
      north_tag = {
        enable = function(self)
          return MinimapNorthTag:SetAlpha(0)
        end,
        disable = function(self)
          return MinimapNorthTag:SetAlpha(1)
        end
      },
      time_display = {
        enable = function(self)
          return _G.TimeManagerClockButton:Hide()
        end,
        disable = function(self)
          return _G.TimeManagerClockButton:Show()
        end
      },
      worldmap_button = {
        enable = function(self)
          return MiniMapWorldMapButton:Hide()
        end,
        disable = function(self)
          return MiniMapWorldMapButton:Show()
        end
      },
      zoom_buttons = {
        enable = function(self)
          MinimapZoomIn:Hide()
          return MinimapZoomOut:Hide()
        end,
        disable = function(self)
          MinimapZoomIn:Show()
          return MinimapZoomOut:Show()
        end
      },
      close_button = {
        enable = function(self)
          if not (idTweaks:is_bc()) then
            return 
          end
          return MinimapToggleButton:Hide()
        end,
        disable = function(self)
          if not (idTweaks:is_bc()) then
            return 
          end
          return MinimapToggleButton:Show()
        end
      }
    },
    hide_check = function(self)
      for name, functions in pairs(self.hide_frames) do
        self:hide_check_frame(name)
      end
    end,
    hide_check_frame = function(self, name)
      if self.db.hide[name] == true then
        return self.hide_frames[name].enable()
      else
        return self.hide_frames[name].disable()
      end
    end,
    hide_disable = function(self)
      for name, functions in pairs(self.hide_frames) do
        self.hide_frames[name].disable()
      end
    end,
    shape_square_check = function(self)
      if self.db.shape.square == true then
        return self:shape_square_enable()
      else
        return self:shape_square_disable()
      end
    end,
    shape_square_enable = function(self)
      Minimap:SetMaskTexture("Interface\\Buttons\\WHITE8x8")
      return MinimapBorder:Hide()
    end,
    shape_square_disable = function(self)
      Minimap:SetMaskTexture("textures\\MinimapMask")
      return MinimapBorder:Show()
    end,
    shape_position_check = function(self)
      return self:shape_position_disable()
    end,
    shape_position_enable = function(self)
      Minimap:ClearAllPoints()
      Minimap:SetParent(UIParent)
      local ActionBars
      ActionBars = idTweaks.modules.ActionBars
      local size = 0
      local bar_margin = ActionBars.db.profile.bar_margin
      local experience_bar_database = idTweaks.modules.ExperienceBar.db.profile
      if experience_bar_database.enabled then
        if experience_bar_database.full_width then
          local _, height = ActionBars:get_total_size()
          size = height
          Minimap:SetPoint(BL, idTweaksActionBar1, BR, bar_margin, bar_margin)
        else
          local _, height = ActionBars:getTotalSize()
          size = height + idTweaksExperienceBar:GetHeight()
          Minimap:SetPoint(BL, idTweaksExperienceBar, BR, bar_margin, bar_margin)
        end
      else
        local _, height = ActionBars:getTotalSize()
        size = height
        Minimap:SetPoint(BL, idTweaksActionBar1, BR, bar_margin, bar_margin)
      end
      Minimap:SetWidth(size)
      return Minimap:SetHeight(size)
    end,
    shape_position_disable = function(self)
      Minimap:ClearAllPoints()
      Minimap:SetParent(MinimapCluster)
      Minimap:SetPoint(MC, MinimapCluster, TC, 9, -92)
      Minimap:SetWidth(140)
      return Minimap:SetHeight(140)
    end,
    mouse_check = function(self)
      return self:mouse_mousewheel_zooming_check()
    end,
    mouse_disable = function(self)
      return self:mouse_mousewheel_zooming_disable()
    end,
    mouse_mousewheel_zooming_check = function(self)
      if self.db.mouse.mouse_wheel_zooming == true then
        return self:mouse_mousewheel_zooming_enable()
      else
        return self:mouse_mousewheel_zooming_disable()
      end
    end,
    mouse_mousewheel_zooming_enable = function(self)
      Minimap:EnableMouseWheel(true)
      return Minimap:SetScript("OnMouseWheel", function(...)
        return self:mouse_handle_mousewheel_zoom(...)
      end)
    end,
    mouse_mousewheel_zooming_disable = function(self)
      Minimap:EnableMouseWheel(false)
      return Minimap:SetScript("OnMouseWheel", nil)
    end,
    mouse_handle_mousewheel_zoom = function(self, frame, delta)
      if delta > 0 and Minimap:GetZoom() < 5 then
        return Minimap:SetZoom(Minimap:GetZoom() + 1)
      elseif delta < 0 and Minimap:GetZoom() > 0 then
        return Minimap:SetZoom(Minimap:GetZoom() - 1)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, "MiniMap", "AceConsole-3.0", "AceEvent-3.0")
    end,
    __base = _base_0,
    __name = "MiniMap",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MiniMap = _class_0
end
minimap_module = MiniMap(idTweaks)
GetMinimapShape = function(self)
  return minimap_module.db.profile.shape.square == true and "SQUARE" or "ROUND"
end
return idTweaks:add_module(minimap_module)
